/*
 * dcf_77.c
 *
 * Created: 01.05.2015 21:56:33
 *  Author: Norbert
 */ 

#include <avr/io.h>
#include "isr.h"
#include "dcf_77.h"

//////////////////////////////////////////////////////////////////////////
// Konstante zum umrechnen von DCF-Zeit zu Dezimal 
static const uint8_t  dcf_tabelle[8] ={1,2,4,8,10,20,40,80};
	
//////////////////////////////////////////////////////////////////////////
// Variablen , global, sichtbar 
DCF_t _DCF;	
	
//////////////////////////////////////////////////////////////////////////
// DCF Fehler Codes !!!!
// _DCF.SYNCRO=0x00 		- DCF wird syncronisiert, Kein DCF paket vollstndig !
// _DCF.SYNCRO=0x01 		- Fehler Bit 20 !=1
// _DCF.SYNCRO=0x02			- Fehler Minuten Paritt nicht OK
// _DCF.SYNCRO=0x04 		- Fehler Stunden Paritt nicht OK
// _DCF.SYNCRO=0x08 		- Fehler Datum Paritt nicht OK

// _DCF.SYNCRO=0x09			- Tag > 31
// _DCF.SYNCRO=0x0A			- Monat > 12 

// _DCF.SYNCRO=0x0B			- Vergleich von 3 DCF Paketen N.I.O. !

//////////////////////////////////////////////////////////////////////////
// alles OKAY !!!
// _DCF.SYNCRO=49		DCF Paket komplett und kann ausgewertet werden
// _DCF.SYNCRO=50 DCF Paket -Paritt, alles OK, und wird sekunden genau bernommen
// _DCF.SYNCRO=0xE8(232) - DCF Zeit wurde bernommen, und wird in 24h wieder aktualisiert
//					es sind nur 8bit also max=255, dann kommt wieder 0 ! (0 = DCF_Zeit neu erfassen !)


void DCF_init(void)
{
	DCF_DDR&=~DCF_PIN;		//DCF_Port = Eingang !
	DCF_PORT|=DCF_PIN;		// Pullup einschalten !
}

//DCF Impulse erfassen und im Speicher ablegen
// die Pausenzeiten zwischen den DCF Impulsen wird ausgewertet !
// das erfassen der Funkzeit ber die Lnge der Pausen ist besser ! und man bekommt weniger Fehler !
// wenn in der Pause zischen 2 Impulsen nur ein kurzer Fehle-Impuls kommt - ist es ein Fehler ! und wird verworfen 
void DCF_erfassen(void)
{
	static uint8_t DCF_signal;
	static uint8_t DCF_old_state;
	
	DCF_signal++;										//erhhe DCF-Signal
	uint8_t DCF_state=(~DCF_IN & DCF_PIN);				// aktueller Status vom DCF _ BIT 
	if (DCF_state!=DCF_old_state)						// Pegelwechsel erkannt ?
	{
		DCF_old_state=DCF_state;								//bernehme aktuellen DCF Status
		if ((DCF_signal>=75) && (DCF_signal<=97))		// DCF Signal zwichen 75 und 95 ? Ja= OKay
		{// - 40ms / + 50ms abweichung
			// 750ms - 800ms Pause =1, 900ms-960ms Pause =0 !
			// orginal: >=75 && <=95 , es werden nicht immer alle impulse erkannt ? 		
			
			
			if (DCF_signal<=85)	_DCF.BUFFER[_DCF.ADR]=1; else _DCF.BUFFER[_DCF.ADR]=0;
			// war 85 (84 knnte schon zu Fehlzeiten fhren !)
			// 86 schein besser zu sein !
			
			// ++DCF_ADR geht nur von 0 bis 59 ! (60 Bytes)
			if (++_DCF.ADR>=59) _DCF.ADR=0;
			DCF_signal=0;
		}
		else if (DCF_signal>=175)
		{
			if (DCF_signal<=185) _DCF.BUFFER[58]=1; else _DCF.BUFFER[58]=0;
			//der letzte Impuls war kleiner/gleich 1840ms = 1 else 0
			
			// waren vor der Pause schon 58 Bits richtig erkannt ?
			//DCF Paket komplett ?? , dann DCF_SYNCRO=49 
			if(_DCF.ADR==58) _DCF.SYNCRO=DCF_PAKET_da;			
			
			DCF_signal=0;
			_DCF.ADR=0;
		}
		else DCF_signal=0;		//nix trifft zu, DCF_Signal lschen !
	}
}


//Paritt vom ganzen DCF Paket auswerten !
void DCF_auswerten(void)
{
	uint8_t p_1=0,i;
	
	//_DCF.BUFFER[20] = 1 ?
 	if(!_DCF.BUFFER[20]) _DCF.SYNCRO=DCF_BIT_20_NIO;	//ist DCF_BIT20 = 0 ??? Dann Fehler !
	
	//////////////////////////////////////////////////////////////////////////
	//Minuten Bits/Paritt berprfen !
	// _DCF.BUFFER[21] - _DCF.BUFFER[28] , 8 Bits
 	for (i=21;i<29;i++){if (_DCF.BUFFER[i]) p_1++;}	//ist der Wert im Pointer !=0 ? dann p_1++ !
	if (p_1 & 0x01) _DCF.SYNCRO=DCF_MINUTEN_PARITAET_NIO;// Minuten Paritt=0, dann alles OK, sonst DCF_SYNCRO=2
		
	//////////////////////////////////////////////////////////////////////////
	//Parittsprfung stunden !
	// _DCF.BUFFER[29] - _DCF.BUFFER[35] , 7 Bits
 	p_1=0;
  	for (i=29;i<36;i++) {if (_DCF.BUFFER[i]) p_1++;}	//Ist Wert im Pointer !=0 ? dann p_1++ !
	if (p_1 & 0x01) _DCF.SYNCRO=DCF_STUNDEN_PARITAET_NIO;// Paritt Stunden , DCF_SYNCRO=3	
	
	//////////////////////////////////////////////////////////////////////////
	//Paritstprfung, Wochentag, Tag, Monat, Jahr
	// _DCF.BUFFER[36] - _DCF.BUFFER[58] , 23 Bits
 	p_1=0;// paritt =0
  	for (i=36;i<59;i++) {if (_DCF.BUFFER[i]) p_1++;}		
 	if (p_1 & 0x01) _DCF.SYNCRO=DCF_DATUM_PARITAET_NIO;	//alles okay ? Bits gerade ? sonst Fehler 0x08			
	


	// ist bis hier her alles OKAY ? , Paket I.O. ? 
	// Dann kopiere Zeit in _DCF.tab_1
	// und berprfe 3 DCF Pakete !
	if (_DCF.SYNCRO==DCF_PAKET_da) 
	{
		// StartBit		_DCF.BUFFER[20]
		_DCF.tab_1[0]=_DCF.BUFFER[20];
		
		//Minuten		DCF_BUFFER[21] - DCF_BUFFER[27]
		_DCF.tab_1[1]=0;
		for (i=0;i<7;i++){_DCF.tab_1[1]+=_DCF.BUFFER[21+i] * dcf_tabelle[i];}
		
		//Stunden		DCF_BUFFER[29] - DCF_BUFFER[34]
		_DCF.tab_1[2]=0;
		for (i=0;i<6;i++){_DCF.tab_1[2]+=_DCF.BUFFER[29+i] * dcf_tabelle[i];}

		//Tag			DCF_BUFFER[36] - DCF_BUFFER[41]
		_DCF.tab_1[3]=0;
		for (i=0;i<6;i++){_DCF.tab_1[3]+=_DCF.BUFFER[36+i] * dcf_tabelle[i];}

		//Wochentag		DCF_BUFFER[42] - DCF_BUFFER[44]
		_DCF.tab_1[4]=0;
		for (i=0;i<3;i++){_DCF.tab_1[4]+=_DCF.BUFFER[42+i] * dcf_tabelle[i];}

		//Monat			DCF_BUFFER[45] - DCF_BUFFER[49]
		_DCF.tab_1[5]=0;
		for (i=0;i<5;i++){_DCF.tab_1[5]+=_DCF.BUFFER[45+i] * dcf_tabelle[i];}
		
		//Jahr			DCF_BUFFER[50] - DCF_BUFFER[57]
		_DCF.tab_1[6]=0;
		for (i=0;i<8;i++){_DCF.tab_1[6]+=_DCF.BUFFER[50+i] * dcf_tabelle[i];}
			
		//berprfe 3 DCF Pakete !
		p_1=0;
		for (i=0;i<7;i++)
		{
			if (_DCF.tab_1[i] != _DCF.tab_2[i]) p_1++;	// DCF_Paket 1 ungleich DCF_Paket 2 , dann Fehler +1
			if (_DCF.tab_1[i] != _DCF.tab_3[i]) p_1++;	// DCF_Paket 1 ungleich DCF_Paket 3 , dann Fehler +1
			_DCF.tab_3[i]=_DCF.tab_2[i];				//kopiere DCF_Zeit 2 zu DCF_ZEIT 3
			_DCF.tab_2[i]=_DCF.tab_1[i];				//kopiere DCF_Zeit 1 zu DCF_ZEIT 2
		}
		
		if (++_DCF.tab_2[1]>=60)			//minuten in DCF Buffer 2 erhhen ! ist 60 ?
		{
			_DCF.tab_2[1]=0;
			_DCF.tab_2[2]++;
		}
		
		if (++_DCF.tab_3[1]>=60)			//minuten in DCF Buffer 3 erhhen ! ist 60 ?
		{
			_DCF.tab_3[1]=0;
			_DCF.tab_3[2]++;
		}
		//Fehler-Zhler =0  ? , dann war alles OKAY !
		if (p_1==0) _DCF.SYNCRO=DCF_PAKET_IO; else _DCF.SYNCRO=DCF_Pakete_ungleich;	
				
	}

	//alles OKAY ???, dann kann Zeit bernommen werden !	***********************************************
	//if (_DCF.SYNCRO==49)_DCF.SYNCRO=50;
	//Wenn alles richtig , dann DCF_SYNCRO=50 , bernehme die Zeit !
	
}
 
//DCF Zeit umrechnen
void DCF_zeit_uebernehmen(void)
{	
	_time.ms=0;
	_time.sekunden=0;
	_time.minuten=	_DCF.tab_1[1];
	_time.stunden=	_DCF.tab_1[2];
	_time.tag=		_DCF.tab_1[3];
	_time.wochentag=_DCF.tab_1[4];
	_time.monat=	_DCF.tab_1[5];
	_time.jahr=		_DCF.tab_1[6];
	
	//////////////////////////////////////////////////////////////////////////
	// DCF Zeit bernommen !!!
	_DCF.SYNCRO=DCF_FERTIG;		// 232 = 0xE8 ! , noch 24 Stunden bis 0x00 !
}