/*
 * dcf_77.h
 *
 * Created: 01.05.2015 21:56:46
 *  Author: Norbert
 */ 


#ifndef DCF_77_H_
#define DCF_77_H_

// DCF Modul von ELV, es gehen auch andere Module (ggf. Spannung anpassen !!!)
#define DCF_PIN			_BV(5)			//an PINC_5
#define DCF_IN			PINC			// an PortC (Eingang ist dann PINC)
#define DCF_DDR			DDRC
#define DCF_PORT		PORTC

#define DCF_BIT_20_NIO				1
#define DCF_MINUTEN_PARITAET_NIO	2
#define DCF_STUNDEN_PARITAET_NIO	4
#define DCF_DATUM_PARITAET_NIO		8
#define DCF_Pakete_ungleich			10

#define DCF_PAKET_da				49
#define DCF_PAKET_IO				50
#define DCF_FERTIG					0xE8 //232 (+24 = 0x00 !)

//////////////////////////////////////////////////////////////////////////
// Struktur DCF_Zeit
typedef struct {				//Definition eines neuen Types, als Struktur
	uint8_t BUFFER[60];			// 60 Bytes im Speiche
	uint8_t ADR;				//aktuelles DCF Byte , Reprsentiert DCF sekunden 
	uint8_t SYNCRO;				// Zeit schon syncron ? oder Fehler !
	uint8_t tab_1[7];
	uint8_t tab_2[7];
	uint8_t tab_3[7];
	} DCF_t;					//Neuer Typ= DCF_t !
	
extern DCF_t _DCF;

//////////////////////////////////////////////////////////////////////////
// DCF Port Konfigurieren ! (Port = Eingang, Pullup ON )
void DCF_init(void);
		
//////////////////////////////////////////////////////////////////////////
// einzelne Bits empfangen und auswerten 
void DCF_erfassen(void);

//////////////////////////////////////////////////////////////////////////
//DCF_zeit auswerten ob kommplet und Okay
void DCF_auswerten(void);

//////////////////////////////////////////////////////////////////////////
// DCF_Zeit bernehmen ! Die ganze Zeit wird als Struktur bergeben !
void DCF_zeit_uebernehmen(void);

/*
DCF Bits Legende 
****************
0.			Minutenbeginn --> immer '0'
1.-14.		keine Bedeutung, normal '0' NEU Wetterdaten(verschlsselt)
15.			Reserveantenne aktiv
16.			Umstellung zwischen Sommer- bzw. Winterzeit
17.			Sommerzeit
18.			Winterzeit
19.			Schaltsekunde
20.			Zeitbeginn				-immer 1 !
21.-27.		Minute 1, 2, 4, 8, 10, 20, 40
28.			Prfbit Minute
29.-34.		Stunde 1, 2, 4, 8, 10, 20
35.			Prfbit Stunde
36.-41.		Tag 1, 2, 4, 8, 10, 20
42.-44.		Wochentag 1, 2, 4
45.-49.		Monat 1, 2, 4, 8, 10
50.-57.		Jahr 1, 2, 4, 8, 10, 20, 40, 80
58.			Prfbit Datum (36. - 57.)
59.			wird nicht gesendet (siehe oben)
*/

#endif /* DCF_77_H_ */